Index: ntoskrnl/kdbg/kdb.c
===================================================================
--- ntoskrnl/kdbg/kdb.c	(revision 21808)
+++ ntoskrnl/kdbg/kdb.c	(working copy)
@@ -80,7 +80,7 @@
 };
 
 /* Exception descriptions */
-STATIC CONST PCHAR ExceptionNrToString[] =
+STATIC CONST CHAR *ExceptionNrToString[] =
 {
    "Divide Error",
    "Debug Trap",
@@ -122,6 +122,14 @@
 KiEspToTrapFrame(IN PKTRAP_FRAME TrapFrame,
                  IN ULONG Esp);
 
+/* ROS Internal. Please deprecate */
+NTHALAPI
+VOID
+NTAPI
+HalReleaseDisplayOwnership(
+    VOID
+);
+
 /* FUNCTIONS *****************************************************************/
 
 STATIC VOID
@@ -183,7 +191,7 @@
    KAPC_STATE ApcState;
 
    /* Get the protection for the address. */
-   Protect = MmGetPageProtect(Process, (PVOID)PAGE_ROUND_DOWN(Address));
+   Protect = MmGetPageProtect((PROS_EPROCESS)Process, (PVOID)PAGE_ROUND_DOWN(Address));
 
    /* Return if that page isn't present. */
    if (Protect & PAGE_NOACCESS)
@@ -200,7 +208,7 @@
    /* Make the page writeable if it is read only. */
    if (Protect & (PAGE_READONLY|PAGE_EXECUTE|PAGE_EXECUTE_READ))
    {
-      MmSetPageProtect(Process, (PVOID)PAGE_ROUND_DOWN(Address),
+      MmSetPageProtect((PROS_EPROCESS)Process, (PVOID)PAGE_ROUND_DOWN(Address),
 	               (Protect & ~(PAGE_READONLY|PAGE_EXECUTE|PAGE_EXECUTE_READ)) | PAGE_READWRITE);
    }
 
@@ -212,7 +220,7 @@
       {
          if (Protect & (PAGE_READONLY|PAGE_EXECUTE|PAGE_EXECUTE_READ))
          {
-            MmSetPageProtect(Process, (PVOID)PAGE_ROUND_DOWN(Address), Protect);
+            MmSetPageProtect((PROS_EPROCESS)Process, (PVOID)PAGE_ROUND_DOWN(Address), Protect);
          }
          /* Detach from process */
          if (CurrentProcess != Process)
@@ -229,7 +237,7 @@
    /* Restore the page protection. */
    if (Protect & (PAGE_READONLY|PAGE_EXECUTE|PAGE_EXECUTE_READ))
    {
-      MmSetPageProtect(Process, (PVOID)PAGE_ROUND_DOWN(Address), Protect);
+      MmSetPageProtect((PROS_EPROCESS)Process, (PVOID)PAGE_ROUND_DOWN(Address), Protect);
    }
 
    /* Detach from process */
@@ -643,13 +651,13 @@
  */
 STATIC LONG
 KdbpIsBreakPointOurs(
-   IN ULONG ExpNr,
+   IN NTSTATUS ExceptionCode,
    IN PKTRAP_FRAME TrapFrame)
 {
    UINT i;
-   ASSERT(ExpNr == 1 || ExpNr == 3);
+   ASSERT(ExceptionCode == STATUS_SINGLE_STEP || ExceptionCode == STATUS_BREAKPOINT);
 
-   if (ExpNr == 3) /* Software interrupt */
+   if (ExceptionCode == STATUS_BREAKPOINT) /* Software interrupt */
    {
       ULONG_PTR BpEip = (ULONG_PTR)TrapFrame->Eip - 1; /* Get EIP of INT3 instruction */
       for (i = 0; i < KdbSwBreakPointCount; i++)
@@ -663,7 +671,7 @@
          }
       }
    }
-   else if (ExpNr == 1) /* Hardware interrupt */
+   else if (ExceptionCode == STATUS_SINGLE_STEP) /* Hardware interrupt */
    {
       UCHAR DebugReg;
       for (i = 0; i < KdbHwBreakPointCount; i++)
@@ -1156,6 +1164,55 @@
    KbdEnableMouse();
 }
 
+STATIC ULONG
+KdbpGetExceptionNumberFromStatus(IN NTSTATUS ExceptionCode)
+{
+    ULONG Ret;
+
+    switch (ExceptionCode)
+    {
+        case STATUS_INTEGER_DIVIDE_BY_ZERO:
+            Ret = 0;
+            break;
+        case STATUS_SINGLE_STEP:
+            Ret = 1;
+            break;
+        case STATUS_BREAKPOINT:
+            Ret = 3;
+            break;
+        case STATUS_INTEGER_OVERFLOW:
+            Ret = 4;
+            break;
+        case STATUS_ARRAY_BOUNDS_EXCEEDED:
+            Ret = 5;
+            break;
+        case STATUS_ILLEGAL_INSTRUCTION:
+            Ret = 6;
+            break;
+        case STATUS_FLOAT_INVALID_OPERATION:
+            Ret = 7;
+            break;
+        case STATUS_STACK_OVERFLOW:
+            Ret = 12;
+            break;
+        case STATUS_ACCESS_VIOLATION:
+            Ret = 14;
+            break;
+        case STATUS_DATATYPE_MISALIGNMENT:
+            Ret = 17;
+            break;
+        case STATUS_FLOAT_MULTIPLE_TRAPS:
+            Ret = 18;
+            break;
+
+        default:
+            Ret = RTL_NUMBER_OF(KdbEnterConditions) - 1;
+            break;
+    }
+
+    return Ret;
+}
+
 /*!\brief KDB Exception filter
  *
  * Called by the exception dispatcher.
@@ -1177,25 +1234,28 @@
    IN OUT PKTRAP_FRAME TrapFrame,
    IN BOOLEAN FirstChance)
 {
-   ULONG ExpNr = (ULONG)TrapFrame->DbgArgMark;
    KDB_ENTER_CONDITION EnterCondition;
    KD_CONTINUE_TYPE ContinueType = kdHandleException;
    PKDB_BREAKPOINT BreakPoint;
-   ULONG ul;
+   ULONG ExpNr;
    ULONGLONG ull;
    BOOLEAN Resume = FALSE;
    BOOLEAN EnterConditionMet = TRUE;
    ULONG OldEflags;
+   NTSTATUS ExceptionCode;
 
+   ExceptionCode = (ExceptionRecord != NULL ? ExceptionRecord->ExceptionCode : STATUS_BREAKPOINT);
+
    KdbCurrentProcess = PsGetCurrentProcess();
 
    /* Set continue type to kdContinue for single steps and breakpoints */
-   if (ExpNr == 1 || ExpNr == 3)
+   if (ExceptionCode == STATUS_SINGLE_STEP || ExceptionCode == STATUS_BREAKPOINT)
       ContinueType = kdContinue;
 
    /* Check if we should handle the exception. */
-   ul = min(ExpNr, RTL_NUMBER_OF(KdbEnterConditions) - 1);
-   EnterCondition = KdbEnterConditions[ul][FirstChance ? 0 : 1];
+   /* FIXME - won't get all exceptions here :( */
+   ExpNr = KdbpGetExceptionNumberFromStatus(ExceptionCode);
+   EnterCondition = KdbEnterConditions[ExpNr][FirstChance ? 0 : 1];
    if (EnterCondition == KdbDoNotEnter ||
        (EnterCondition == KdbEnterFromUmode && PreviousMode == KernelMode) ||
        (EnterCondition == KdbEnterFromKmode && PreviousMode != KernelMode))
@@ -1207,12 +1267,12 @@
    KdbLastBreakPointNr = -1;
    KdbEnteredOnSingleStep = FALSE;
 
-   if (FirstChance && (ExpNr == 1 || ExpNr == 3) &&
-       (KdbLastBreakPointNr = KdbpIsBreakPointOurs(ExpNr, TrapFrame)) >= 0)
+   if (FirstChance && (ExceptionCode == STATUS_SINGLE_STEP || ExceptionCode == STATUS_BREAKPOINT) &&
+       (KdbLastBreakPointNr = KdbpIsBreakPointOurs(ExceptionCode, TrapFrame)) >= 0)
    {
       BreakPoint = KdbBreakPoints + KdbLastBreakPointNr;
 
-      if (ExpNr == 3)
+      if (ExceptionCode == STATUS_BREAKPOINT)
       {
          /*
           * The breakpoint will point to the next instruction by default so
@@ -1272,7 +1332,7 @@
       else if (BreakPoint->Type == KdbBreakPointSoftware ||
                BreakPoint->Type == KdbBreakPointTemporary)
       {
-         ASSERT(ExpNr == 3);
+         ASSERT(ExceptionCode == STATUS_BREAKPOINT);
          TrapFrame->EFlags |= X86_EFLAGS_TF;
          KdbBreakPointToReenable = BreakPoint;
       }
@@ -1322,7 +1382,7 @@
 
       }
    }
-   else if (ExpNr == 1)
+   else if (ExceptionCode == STATUS_SINGLE_STEP)
    {
       /* Silently ignore a debugger initiated single step. */
       if ((TrapFrame->Dr6 & 0xf) == 0 && KdbBreakPointToReenable != NULL)
@@ -1380,7 +1440,7 @@
          DbgPrint("Entered debugger on unexpected debug trap!\n");
       }
    }
-   else if (ExpNr == 3)
+   else if (ExceptionCode == STATUS_BREAKPOINT)
    {
       if (KdbInitFileBuffer != NULL)
       {
@@ -1397,7 +1457,7 @@
    }
    else
    {
-      CONST PCHAR ExceptionString = (ExpNr < RTL_NUMBER_OF(ExceptionNrToString)) ?
+      CONST CHAR *ExceptionString = (ExpNr < RTL_NUMBER_OF(ExceptionNrToString)) ?
                                     (ExceptionNrToString[ExpNr]) :
                                     ("Unknown/User defined exception");
 
@@ -1406,9 +1466,10 @@
          return ContinueType;
       }
 
-      DbgPrint("Entered debugger on %s-chance exception number %d (%s)\n",
-               FirstChance ? "first" : "last", ExpNr, ExceptionString);
-      if (ExpNr == 14)
+      DbgPrint("Entered debugger on %s-chance exception (Exception Code: 0x%x) (%s)\n",
+               FirstChance ? "first" : "last", ExceptionCode, ExceptionString);
+      if (ExceptionCode == STATUS_ACCESS_VIOLATION &&
+          ExceptionRecord != NULL && ExceptionRecord->NumberParameters != 0)
       {
          /* FIXME: Add noexec memory stuff */
          ULONG_PTR Cr2;
@@ -1491,7 +1552,7 @@
 
 continue_execution:
    /* Clear debug status */
-   if (ExpNr == 1 || ExpNr == 3) /* FIXME: Why clear DR6 on INT3? */
+   if (ExceptionCode == STATUS_SINGLE_STEP || ExceptionCode == STATUS_BREAKPOINT) /* FIXME: Why clear DR6 on INT3? */
    {
       /* Set the RF flag so we don't trigger the same breakpoint again. */
       if (Resume)
Index: ntoskrnl/kdbg/kdb_cli.c
===================================================================
--- ntoskrnl/kdbg/kdb_cli.c	(revision 21808)
+++ ntoskrnl/kdbg/kdb_cli.c	(working copy)
@@ -1453,7 +1453,7 @@
              Pcr->IDR, Pcr->KdVersionBlock, Pcr->IDT, Pcr->GDT, Pcr->TSS,
              Pcr->MajorVersion, Pcr->MinorVersion, Pcr->SetMember, Pcr->StallScaleFactor,
              Pcr->Number, Pcr->L2CacheAssociativity,
-             Pcr->VdmAlert, Pcr->L2CacheSize, Pcr->InterruptMode);
+             Pcr->VdmAlert, Pcr->SecondLevelCacheSize, Pcr->InterruptMode);
 
    return TRUE;
 }
Index: ntoskrnl/kdbg/kdb_symbols.c
===================================================================
--- ntoskrnl/kdbg/kdb_symbols.c	(revision 21808)
+++ ntoskrnl/kdbg/kdb_symbols.c	(working copy)
@@ -73,7 +73,7 @@
   while (current_entry != &Peb->Ldr->InLoadOrderModuleList &&
          current_entry != NULL)
     {
-      current = CONTAINING_RECORD(current_entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+      current = CONTAINING_RECORD(current_entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
       Length = min(current->BaseDllName.Length / sizeof(WCHAR), 255);
       if ((Address != NULL && (Address >= (PVOID)current->DllBase &&
                                Address < (PVOID)((char *)current->DllBase + current->SizeOfImage))) ||
@@ -115,7 +115,7 @@
 
   while (current_entry != &ModuleListHead)
     {
-      current = CONTAINING_RECORD(current_entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+      current = CONTAINING_RECORD(current_entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
 
       Length = min(current->BaseDllName.Length / sizeof(WCHAR), 255);
       if ((Address != NULL && (Address >= (PVOID)current->DllBase &&
@@ -537,7 +537,7 @@
   while (CurrentEntry != &Peb->Ldr->InLoadOrderModuleList &&
 	 CurrentEntry != NULL)
     {
-      Current = CONTAINING_RECORD(CurrentEntry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+      Current = CONTAINING_RECORD(CurrentEntry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
 
       KdbpSymUnloadModuleSymbols(Current->PatchInformation);
 
Index: ntoskrnl/ntoskrnl.def
===================================================================
--- ntoskrnl/ntoskrnl.def	(revision 21808)
+++ ntoskrnl/ntoskrnl.def	(working copy)
@@ -1116,8 +1116,8 @@
 RtlIpv4StringToAddressExW@16
 RtlIpv4StringToAddressW@16
 RtlIpv6AddressToStringA@8
-RtlIpv6AddressToStringExA@16
-RtlIpv6AddressToStringExW@16
+RtlIpv6AddressToStringExA@20
+RtlIpv6AddressToStringExW@20
 RtlIpv6AddressToStringW@8
 RtlIpv6StringToAddressA@12
 RtlIpv6StringToAddressExA@16
Index: ntoskrnl/mm/section.c
===================================================================
--- ntoskrnl/mm/section.c	(revision 21808)
+++ ntoskrnl/mm/section.c	(working copy)
@@ -60,7 +60,7 @@
 
 typedef struct
 {
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    PMM_SECTION_SEGMENT Segment;
    ULONG Offset;
    BOOLEAN WasDirty;
@@ -316,7 +316,7 @@
 
 BOOLEAN
 NTAPI
-MmUnsharePageEntrySectionSegment(PSECTION_OBJECT Section,
+MmUnsharePageEntrySectionSegment(PROS_SECTION_OBJECT Section,
                                  PMM_SECTION_SEGMENT Segment,
                                  ULONG Offset,
                                  BOOLEAN Dirty,
@@ -646,7 +646,7 @@
    PFN_TYPE Page;
    NTSTATUS Status;
    PVOID PAddress;
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    PMM_SECTION_SEGMENT Segment;
    ULONG Entry;
    ULONG Entry1;
@@ -1162,7 +1162,7 @@
                          BOOLEAN Locked)
 {
    PMM_SECTION_SEGMENT Segment;
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    PFN_TYPE OldPage;
    PFN_TYPE NewPage;
    NTSTATUS Status;
@@ -1329,7 +1329,7 @@
 }
 
 VOID
-MmPageOutDeleteMapping(PVOID Context, PEPROCESS Process, PVOID Address)
+MmPageOutDeleteMapping(PVOID Context, PROS_EPROCESS Process, PVOID Address)
 {
    MM_SECTION_PAGEOUT_CONTEXT* PageOutContext;
    BOOLEAN WasDirty;
@@ -1353,7 +1353,7 @@
    if (!PageOutContext->Private)
    {
       MmLockSectionSegment(PageOutContext->Segment);
-      MmUnsharePageEntrySectionSegment(PageOutContext->Section,
+      MmUnsharePageEntrySectionSegment((PROS_SECTION_OBJECT)PageOutContext->Section,
                                        PageOutContext->Segment,
                                        PageOutContext->Offset,
                                        PageOutContext->WasDirty,
@@ -1734,7 +1734,7 @@
                        PMM_PAGEOP PageOp)
 {
    ULONG Offset;
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    PMM_SECTION_SEGMENT Segment;
    PFN_TYPE Page;
    SWAPENTRY SwapEntry;
@@ -1980,7 +1980,7 @@
 {
    PMM_REGION Region;
    PVOID RegionBaseAddress;
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    PMM_SECTION_SEGMENT Segment;
 
    Region = MmFindRegion((PVOID)MemoryArea->StartingAddress,
@@ -2054,7 +2054,7 @@
 VOID STDCALL
 MmpDeleteSection(PVOID ObjectBody)
 {
-   PSECTION_OBJECT Section = (PSECTION_OBJECT)ObjectBody;
+   PROS_SECTION_OBJECT Section = (PROS_SECTION_OBJECT)ObjectBody;
 
    DPRINT("MmpDeleteSection(ObjectBody %x)\n", ObjectBody);
    if (Section->AllocationAttributes & SEC_IMAGE)
@@ -2123,11 +2123,14 @@
 }
 
 VOID STDCALL
-MmpCloseSection(PVOID ObjectBody,
-                ULONG HandleCount)
+MmpCloseSection(IN PEPROCESS Process OPTIONAL,
+                IN PVOID Object,
+                IN ACCESS_MASK GrantedAccess,
+                IN ULONG ProcessHandleCount,
+                IN ULONG SystemHandleCount)
 {
    DPRINT("MmpCloseSection(OB %x, HC %d) RC %d\n",
-          ObjectBody, HandleCount, ObGetObjectPointerCount(ObjectBody));
+          Object, ProcessHandleCount, ObGetObjectPointerCount(Object));
 }
 
 NTSTATUS
@@ -2135,7 +2138,7 @@
 NTAPI
 MmCreatePhysicalMemorySection(VOID)
 {
-   PSECTION_OBJECT PhysSection;
+   PROS_SECTION_OBJECT PhysSection;
    NTSTATUS Status;
    OBJECT_ATTRIBUTES Obj;
    UNICODE_STRING Name = RTL_CONSTANT_STRING(L"\\Device\\PhysicalMemory");
@@ -2206,7 +2209,7 @@
 
 NTSTATUS
 NTAPI
-MmCreatePageFileSection(PSECTION_OBJECT *SectionObject,
+MmCreatePageFileSection(PROS_SECTION_OBJECT *SectionObject,
                         ACCESS_MASK DesiredAccess,
                         POBJECT_ATTRIBUTES ObjectAttributes,
                         PLARGE_INTEGER UMaximumSize,
@@ -2217,7 +2220,7 @@
  */
 {
    LARGE_INTEGER MaximumSize;
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    PMM_SECTION_SEGMENT Segment;
    NTSTATUS Status;
 
@@ -2278,7 +2281,7 @@
 
 NTSTATUS
 NTAPI
-MmCreateDataFileSection(PSECTION_OBJECT *SectionObject,
+MmCreateDataFileSection(PROS_SECTION_OBJECT *SectionObject,
                         ACCESS_MASK DesiredAccess,
                         POBJECT_ATTRIBUTES ObjectAttributes,
                         PLARGE_INTEGER UMaximumSize,
@@ -2289,7 +2292,7 @@
  * Create a section backed by a data file
  */
 {
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    NTSTATUS Status;
    LARGE_INTEGER MaximumSize;
    PFILE_OBJECT FileObject;
@@ -3170,7 +3173,7 @@
 }
 
 NTSTATUS
-MmCreateImageSection(PSECTION_OBJECT *SectionObject,
+MmCreateImageSection(PROS_SECTION_OBJECT *SectionObject,
                      ACCESS_MASK DesiredAccess,
                      POBJECT_ATTRIBUTES ObjectAttributes,
                      PLARGE_INTEGER UMaximumSize,
@@ -3178,7 +3181,7 @@
                      ULONG AllocationAttributes,
                      HANDLE FileHandle)
 {
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    NTSTATUS Status;
    PFILE_OBJECT FileObject;
    PMM_SECTION_SEGMENT SectionSegments;
@@ -3484,7 +3487,7 @@
 
 NTSTATUS STATIC
 MmMapViewOfSegment(PMADDRESS_SPACE AddressSpace,
-                   PSECTION_OBJECT Section,
+                   PROS_SECTION_OBJECT Section,
                    PMM_SECTION_SEGMENT Segment,
                    PVOID* BaseAddress,
                    SIZE_T ViewSize,
@@ -3591,8 +3594,8 @@
    PVOID SafeBaseAddress;
    LARGE_INTEGER SafeSectionOffset;
    SIZE_T SafeViewSize;
-   PSECTION_OBJECT Section;
-   PEPROCESS Process;
+   PROS_SECTION_OBJECT Section;
+   PROS_EPROCESS Process;
    KPROCESSOR_MODE PreviousMode;
    PMADDRESS_SPACE AddressSpace;
    NTSTATUS Status = STATUS_SUCCESS;
@@ -3689,7 +3692,7 @@
    }
 
    Status = MmMapViewOfSection(Section,
-                               Process,
+                               (PEPROCESS)Process,
                                (BaseAddress != NULL ? &SafeBaseAddress : NULL),
                                ZeroBits,
                                CommitSize,
@@ -3741,7 +3744,7 @@
    SWAPENTRY SavedSwapEntry;
    PMM_PAGEOP PageOp;
    NTSTATUS Status;
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    PMM_SECTION_SEGMENT Segment;
    PMADDRESS_SPACE AddressSpace;
 
@@ -3843,7 +3846,7 @@
 {
    NTSTATUS Status;
    PMEMORY_AREA MemoryArea;
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    PMM_SECTION_SEGMENT Segment;
    PLIST_ENTRY CurrentEntry;
    PMM_REGION CurrentRegion;
@@ -3899,7 +3902,7 @@
    NTSTATUS Status;
    PMEMORY_AREA MemoryArea;
    PMADDRESS_SPACE AddressSpace;
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    PMM_PAGEOP PageOp;
    ULONG_PTR Offset;
 
@@ -3908,7 +3911,7 @@
 
    ASSERT(Process);
 
-   AddressSpace = &Process->AddressSpace;
+   AddressSpace = &((PROS_EPROCESS)Process)->AddressSpace;
    
    MmLockAddressSpace(AddressSpace);
    MemoryArea = MmLocateMemoryAreaByAddress(AddressSpace,
@@ -4088,7 +4091,7 @@
                IN ULONG SectionInformationLength,
                OUT PULONG ResultLength  OPTIONAL)
 {
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    KPROCESSOR_MODE PreviousMode;
    NTSTATUS Status = STATUS_SUCCESS;
 
@@ -4216,7 +4219,7 @@
                 IN PLARGE_INTEGER NewMaximumSize)
 {
    LARGE_INTEGER SafeNewMaximumSize;
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    KPROCESSOR_MODE PreviousMode;
    NTSTATUS Status = STATUS_SUCCESS;
 
@@ -4408,7 +4411,7 @@
                    IN ULONG AllocationType,
                    IN ULONG Protect)
 {
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    PMADDRESS_SPACE AddressSpace;
    ULONG ViewOffset;
    NTSTATUS Status = STATUS_SUCCESS;
@@ -4428,8 +4431,8 @@
    }
 
 
-   Section = (PSECTION_OBJECT)SectionObject;
-   AddressSpace = &Process->AddressSpace;
+   Section = (PROS_SECTION_OBJECT)SectionObject;
+   AddressSpace = &((PROS_EPROCESS)Process)->AddressSpace;
 
    AllocationType |= (Section->AllocationAttributes & SEC_NO_CHANGE);
 
@@ -4655,13 +4658,13 @@
                         OUT PVOID * MappedBase,
                         IN OUT PULONG ViewSize)
 {
-   PSECTION_OBJECT Section;
+   PROS_SECTION_OBJECT Section;
    PMADDRESS_SPACE AddressSpace;
    NTSTATUS Status;
 
    DPRINT("MmMapViewInSystemSpace() called\n");
 
-   Section = (PSECTION_OBJECT)SectionObject;
+   Section = (PROS_SECTION_OBJECT)SectionObject;
    AddressSpace = MmGetKernelAddressSpace();
 
    MmLockAddressSpace(AddressSpace);
@@ -4823,7 +4826,7 @@
                  IN PFILE_OBJECT  File      OPTIONAL)
 {
    ULONG Protection;
-   PSECTION_OBJECT *SectionObject = (PSECTION_OBJECT *)Section;
+   PROS_SECTION_OBJECT *SectionObject = (PROS_SECTION_OBJECT *)Section;
 
    /*
     * Check the protection
Index: ntoskrnl/mm/mm.c
===================================================================
--- ntoskrnl/mm/mm.c	(revision 21808)
+++ ntoskrnl/mm/mm.c	(working copy)
@@ -30,7 +30,7 @@
 
 NTSTATUS 
 NTAPI
-MmReleaseMmInfo(PEPROCESS Process)
+MmReleaseMmInfo(PROS_EPROCESS Process)
 {
    PVOID Address;
    PMEMORY_AREA MemoryArea;
@@ -47,7 +47,7 @@
          case MEMORY_AREA_SECTION_VIEW:
              Address = (PVOID)MemoryArea->StartingAddress;
              MmUnlockAddressSpace(&Process->AddressSpace);
-             MmUnmapViewOfSection(Process, Address);
+             MmUnmapViewOfSection((PEPROCESS)Process, Address);
              MmLockAddressSpace(&Process->AddressSpace);
              break;
 
@@ -114,7 +114,7 @@
    }
    else
    {
-      AddressSpace = &PsGetCurrentProcess()->AddressSpace;
+      AddressSpace = &((PROS_EPROCESS)PsGetCurrentProcess())->AddressSpace;
    }
 
    MmLockAddressSpace(AddressSpace);
@@ -171,7 +171,7 @@
    }
    else
    {
-      AddressSpace = &PsGetCurrentProcess()->AddressSpace;
+      AddressSpace = &((PROS_EPROCESS)PsGetCurrentProcess())->AddressSpace;
    }
 
    if (!FromMdl)
@@ -304,7 +304,7 @@
    }
    else
    {
-      AddressSpace = &PsGetCurrentProcess()->AddressSpace;
+      AddressSpace = &((PROS_EPROCESS)PsGetCurrentProcess())->AddressSpace;
    }
 
    if (!FromMdl)
@@ -357,7 +357,7 @@
          case MEMORY_AREA_SHARED_DATA:
 	    Pfn = MmSharedDataPagePhysicalAddress.QuadPart >> PAGE_SHIFT;
             Status =
-               MmCreateVirtualMapping(PsGetCurrentProcess(),
+               MmCreateVirtualMapping((PROS_EPROCESS)PsGetCurrentProcess(),
                                       (PVOID)PAGE_ROUND_DOWN(Address),
                                       PAGE_READONLY,
                                       &Pfn,
Index: ntoskrnl/mm/mdl.c
===================================================================
--- ntoskrnl/mm/mdl.c	(revision 21808)
+++ ntoskrnl/mm/mdl.c	(working copy)
@@ -241,7 +241,7 @@
    /* Unmap all the pages. */
    for (i = 0; i < PageCount; i++)
    {
-      MmDeleteVirtualMapping(Mdl->Process,
+      MmDeleteVirtualMapping((PROS_EPROCESS)Mdl->Process,
                              (char*)BaseAddress + (i * PAGE_SIZE),
                              FALSE,
                              NULL,
@@ -273,14 +273,14 @@
 
       ASSERT(Mdl->Process == PsGetCurrentProcess());
 
-      Marea = MmLocateMemoryAreaByAddress( &Mdl->Process->AddressSpace, BaseAddress );
+      Marea = MmLocateMemoryAreaByAddress( &((PROS_EPROCESS)Mdl->Process)->AddressSpace, BaseAddress );
       if (Marea == NULL)
       {
          DPRINT1( "Couldn't open memory area when unmapping user-space pages!\n" );
          KEBUGCHECK(0);
       }
 
-      MmFreeMemoryArea( &Mdl->Process->AddressSpace, Marea, NULL, NULL );
+      MmFreeMemoryArea( &((PROS_EPROCESS)Mdl->Process)->AddressSpace, Marea, NULL, NULL );
 
       Mdl->Process = NULL;
    }
@@ -411,7 +411,7 @@
       /* FIXME: why isn't AccessMode used? */
       Mode = UserMode;
       Mdl->Process = CurrentProcess;
-      AddressSpace = &CurrentProcess->AddressSpace;
+      AddressSpace = &((PROS_EPROCESS)CurrentProcess)->AddressSpace;
    }
 
 
@@ -771,7 +771,7 @@
    KIRQL oldIrql;
    ULONG PageCount;
    ULONG StartingOffset;
-   PEPROCESS CurrentProcess;
+   PROS_EPROCESS CurrentProcess;
    NTSTATUS Status;
    ULONG Protect;
 
@@ -803,7 +803,7 @@
       BoundaryAddressMultiple.QuadPart = 0;
       Base = BaseAddress;
 
-      CurrentProcess = PsGetCurrentProcess();
+      CurrentProcess = (PROS_EPROCESS)PsGetCurrentProcess();
 
       MmLockAddressSpace(&CurrentProcess->AddressSpace);
       Status = MmCreateMemoryArea(&CurrentProcess->AddressSpace,
@@ -828,7 +828,7 @@
          ASSERT(0);
       }
 
-      Mdl->Process = CurrentProcess;
+      Mdl->Process = (PEPROCESS)CurrentProcess;
    }
    else /* if (AccessMode == KernelMode) */
    {
Index: ntoskrnl/mm/process.c
===================================================================
--- ntoskrnl/mm/process.c	(revision 21808)
+++ ntoskrnl/mm/process.c	(working copy)
@@ -25,7 +25,7 @@
 
 PVOID
 STDCALL
-MiCreatePebOrTeb(PEPROCESS Process,
+MiCreatePebOrTeb(PROS_EPROCESS Process,
                  PVOID BaseAddress)
 {
     NTSTATUS Status;
@@ -107,7 +107,7 @@
 
 VOID
 STDCALL
-MmDeleteTeb(PEPROCESS Process,
+MmDeleteTeb(PROS_EPROCESS Process,
             PTEB Teb)
 {
     PMADDRESS_SPACE ProcessAddressSpace = &Process->AddressSpace;
@@ -220,7 +220,7 @@
 
 NTSTATUS
 STDCALL
-MmCreatePeb(PEPROCESS Process)
+MmCreatePeb(PROS_EPROCESS Process)
 {
     PPEB Peb = NULL;
     LARGE_INTEGER SectionOffset;
@@ -241,7 +241,7 @@
     /* Map NLS Tables */
     DPRINT("Mapping NLS\n");
     Status = MmMapViewOfSection(NlsSectionObject,
-                                Process,
+                                (PEPROCESS)Process,
                                 &TableBase,
                                 0,
                                 0,
@@ -357,7 +357,7 @@
 
 PTEB
 STDCALL
-MmCreateTeb(PEPROCESS Process,
+MmCreateTeb(PROS_EPROCESS Process,
             PCLIENT_ID ClientId,
             PINITIAL_TEB InitialTeb)
 {
@@ -366,7 +366,7 @@
 
     /* Attach to the process */
     DPRINT("MmCreateTeb\n");
-    if (Process != PsGetCurrentProcess())
+    if (Process != (PROS_EPROCESS)PsGetCurrentProcess())
     {
         /* Attach to Target */
         KeAttachProcess(&Process->Pcb);
@@ -407,8 +407,8 @@
 
 NTSTATUS
 STDCALL
-MmCreateProcessAddressSpace(IN PEPROCESS Process,
-                            IN PSECTION_OBJECT Section OPTIONAL)
+MmCreateProcessAddressSpace(IN PROS_EPROCESS Process,
+                            IN PROS_SECTION_OBJECT Section OPTIONAL)
 {
     NTSTATUS Status;
     PMADDRESS_SPACE ProcessAddressSpace = &Process->AddressSpace;
@@ -491,7 +491,7 @@
         DPRINT("Mapping process image. Section: %p, Process: %p, ImageBase: %p\n",
                  Section, Process, &ImageBase);
         Status = MmMapViewOfSection(Section,
-                                    Process,
+                                    (PEPROCESS)Process,
                                     (PVOID*)&ImageBase,
                                     0,
                                     0,
Index: ntoskrnl/mm/marea.c
===================================================================
--- ntoskrnl/mm/marea.c	(revision 21808)
+++ ntoskrnl/mm/marea.c	(working copy)
@@ -747,7 +747,7 @@
    PMEMORY_AREA *ParentReplace;
    ULONG_PTR Address;
    PVOID EndAddress;
-   PEPROCESS CurrentProcess = PsGetCurrentProcess();
+   PROS_EPROCESS CurrentProcess = (PROS_EPROCESS)PsGetCurrentProcess();
 
    if (AddressSpace->Process != NULL &&
        AddressSpace->Process != CurrentProcess)
@@ -1025,7 +1025,7 @@
 
 
 VOID STDCALL
-MmReleaseMemoryAreaIfDecommitted(PEPROCESS Process,
+MmReleaseMemoryAreaIfDecommitted(PROS_EPROCESS Process,
                                  PMADDRESS_SPACE AddressSpace,
                                  PVOID BaseAddress)
 {
Index: ntoskrnl/mm/virtual.c
===================================================================
--- ntoskrnl/mm/virtual.c	(revision 21808)
+++ ntoskrnl/mm/virtual.c	(working copy)
@@ -119,7 +119,7 @@
                       OUT PULONG ResultLength)
 {
    NTSTATUS Status;
-   PEPROCESS Process;
+   PROS_EPROCESS Process;
    MEMORY_AREA* MemoryArea;
    PMADDRESS_SPACE AddressSpace;
 
@@ -393,7 +393,7 @@
       PAGE_ROUND_DOWN(*BaseAddress);
    *BaseAddress = (PVOID)PAGE_ROUND_DOWN(*BaseAddress);
 
-   AddressSpace = &Process->AddressSpace;
+   AddressSpace = &((PROS_EPROCESS)Process)->AddressSpace;
 
    MmLockAddressSpace(AddressSpace);
    MemoryArea = MmLocateMemoryAreaByAddress(AddressSpace, *BaseAddress);
Index: ntoskrnl/mm/anonmem.c
===================================================================
--- ntoskrnl/mm/anonmem.c	(revision 21808)
+++ ntoskrnl/mm/anonmem.c	(working copy)
@@ -544,7 +544,7 @@
  * RETURNS: Status
  */
 {
-   PEPROCESS Process;
+   PROS_EPROCESS Process;
    MEMORY_AREA* MemoryArea;
    ULONG_PTR MemoryAreaLength;
    ULONG Type;
@@ -784,7 +784,7 @@
          MmFreeSwapPage(SavedSwapEntry);
          MmSetSavedSwapEntryPage(Page, 0);
       }
-      MmDeleteRmap(Page, Process, Address);
+      MmDeleteRmap(Page, (PROS_EPROCESS)Process, Address);
       MmReleasePageMemoryConsumer(MC_USER, Page);
    }
    else if (SwapEntry != 0)
@@ -795,7 +795,7 @@
 
 VOID
 NTAPI
-MmFreeVirtualMemory(PEPROCESS Process,
+MmFreeVirtualMemory(PROS_EPROCESS Process,
                     PMEMORY_AREA MemoryArea)
 {
    PLIST_ENTRY current_entry;
@@ -889,7 +889,7 @@
 {
    MEMORY_AREA* MemoryArea;
    NTSTATUS Status;
-   PEPROCESS Process;
+   PROS_EPROCESS Process;
    PMADDRESS_SPACE AddressSpace;
    PVOID BaseAddress;
    ULONG RegionSize;
